<template>
  <el-table v-if="tableData.length > 0"
            :data="
      tableData.filter(
        (data) =>
          !search || data.name.toLowerCase().includes(search.toLowerCase())
      )
    "
            row-key="shortName"
            lazy
            :load="getImageEntries"
            :tree-props="{ children: 'children', hasChildren: 'count' }"
            style="width: 100%">
    <el-table-column label="Symbol" :sortable="true" prop="shortName"/>
    <el-table-column label="Entries" :sortable="true" prop="count"/>
    <el-table-column label="Id" prop="id"/>
    <el-table-column label="Images" prop="imageCount"/>
    <el-table-column align="right">
      <template #header>
        <el-input v-model="search" size="mini" placeholder="Type to search"/>
      </template>
      <template #default="scope">
        <router-link v-if="scope.row.id" :to="{name: 'stock', params: {stockId: scope.row.id}}">
          <el-button size="mini" @click="handleEdit(scope.$index, scope.row)"
          >View
          </el-button>
        </router-link>
      </template>
    </el-table-column>
  </el-table>
</template>


<script>
import apiCalls from "@/apiCalls";

export default {
  name: "StocksList",
  data() {
    return {
      tableData: [],
      search: '',
    }
  },
  methods: {
    handleEdit(index, row) {
      console.log(index, row.id)
    },
    load(row, treeNode, resolve) {
      setTimeout(() => {
        resolve([
          {
            id: 5,
            count: '2',
          },
          {
            id: 6,
            count: '5',
          },
        ])
      }, 1000)
    },
    setTableData() {
      apiCalls.getImageItemsPreview().then(res => res.data).then(data => this.tableData = data)
    },
    getImageEntries(row, treeNode, resolve) {
      apiCalls.getImageItems(row.shortName).then(res => res.data).then(data => resolve(data));
    }
  },
  created() {
    this.setTableData();
  }
}
</script>

<style scoped>

</style>